(function($,exports){

        console.debug("twitter preload ...")

        var x = /^https?:\/\/(?:(?:(?:m(?:obile)?)|(?:www)|)\.)?twitter\.com/,
        P = /\/@?([_\w\d]+)\/status(?:es)?\/([\d]+)\/?/,
        R = new RegExp("" + x.source + P.source)

        if (window._fas_tweetVideos === undefined) {
            window._fas_tweetVideos = []
        }

        if (window._fas_tweetPictures === undefined) {
            window._fas_tweetPictures = []
        }

        window._fas_latestPathNameTested = ""
        window._fas_latestPathNameTestedPicture = ""

        window._fas_completedProcesses = {}
        window._fas_checkCompletedProcesses = (function() {
            return window._fas_completedProcesses['ad_detection'] === true
                   && window._fas_completedProcesses['badge_detection'] === true
        })

        window._fas_processCompleted = (function(name) {
            window._fas_completedProcesses[name] = true
            if (window._fas_checkCompletedProcesses()) {
                window._fas_closeService()
            }
        })

        window._fas_closeService = (function() {
            if ("_close_" in window) {
                _close_.destroy()
            }
        })

        function parsePermalinkUrl(e) {
            var t = e && e.match(R);
            if (t && t.length === 3) {
                return {
                    screenName: t[1],
                    statusId: t[2]
                }
            }
        }

        function getUserPropertyFromID(users, advertiserID, property) {
            if (users !== undefined) {
                for (var userID in users) {
                    if (users.hasOwnProperty(userID)) {
                        var user = users[userID]
                        console.debug('getUserPropertyFromID  users[userID]',  users[userID])
                        if (user['id_str'] === advertiserID) {
                            return user[property]
                        }
                    }
                }
            }
            return advertiserID
        }

        function parsingAds(json, originURL) {
        	var instructions = json.getValueForKeyPath("data.home.home_timeline_urt.instructions")
            if (instructions === undefined) {
                return
            }
            var newInstructions = []

            instructions.forEach(function(instruction) {
                if (instruction.entries === undefined) {
                    return
                }

                var entries = instruction.entries
                var newEntries = []

                entries.forEach(function(entry) {
                    try {
                        var itemContent = entry.getValueForKeyPath("content.itemContent")
                        if (itemContent !== undefined) {
                            var tweet = itemContent.getValueForKeyPath("tweet_results.result.legacy")
                            var promotedMetadata = itemContent.getValueForKeyPath("promotedMetadata")
                            var user_id = itemContent.getValueForKeyPath("tweet_results.result.core.user_results.result.rest_id")
                            var user = itemContent.getValueForKeyPath("tweet_results.result.core.user_results.result.legacy")
                            var users = {}
                            users[user_id] = user
                            exports.TweetsDB.indexTweet(tweet, originURL, users);
                            if (promotedMetadata && tweet != undefined) {
                                exports.TweetsDB.markTweetAsSponsored(tweet.id_str)
                            }
                            if (!promotedMetadata || !window.OW_hasAdBlockFeature) {
                                newEntries.push(entry)
                            }
                        } else {
                            newEntries.push(entry)
                        }
                    } catch(ex) {
                        console.error("[FEED] entry error",ex)
                        newEntries.push(entry)
                    }
                })
                var newInstruction = instruction
                newInstruction.entries = newEntries
                newInstructions.push(newInstruction)
           })
           var newJSON = json
           var data = json.data
           var home = data.home
           var home_timeline_urt = home.home_timeline_urt
           home_timeline_urt.instructions = newInstructions
           home.home_timeline_urt = home_timeline_urt
           data.home = home
           json.data = data
           return JSON.stringify(json)
        }

		XMLHttpRequest.prototype.handleJSONResponse = function(json, originURL){
		    try {
		        if (json === undefined) {
                    return;
                }
		        if (originURL.indexOf("/HomeLatestTimeline") > 0
                    || originURL.indexOf("/HomeTimeline") > 0) {
                    return parsingAds(json, originURL)
                }

		        if (originURL.indexOf("/2/timeline/") > 0
               	    || originURL.indexOf("/2/live_event/timeline/") > 0
               	    || originURL.indexOf("/2/guide") > 0
               	    || originURL.indexOf("/2/search") > 0) {
               	    var newJSON = json
		            var tweets = json.globalObjects.tweets
		            var users = json.globalObjects.users

		            for (var tweetID in tweets) {
                        if (tweets.hasOwnProperty(tweetID)) {
                            var tweet = tweets[tweetID]
                            exports.TweetsDB.indexTweet(tweets[tweetID], originURL, users)
                            if (tweet.extended_entities !== undefined
                                && tweet.extended_entities.media !== undefined) {
                                var medias = tweet.extended_entities.media
                                var videos = []
                                var pictures = []
                                var index = 1
                                medias.forEach(function (media){
                                    if (media.video_info !== undefined) {
                                        videos.push(media)
                                    }
                                    else if (media.media_url !== undefined) {
                                        var data =  parsePermalinkUrl(media.expanded_url)
                                        media['permaLink'] = "/" + data.screenName + "/status/" + data.statusId + "/photo/" + index
                                        pictures.push(media)
                                        index++
                                    }
                                })
                                if (videos.length > 0) {
                                    window._fas_tweetVideos.push({tweetID:tweetID, videos:videos})
                                }
                                if (pictures.length > 0) {
                                    window._fas_tweetPictures.push({tweetID:tweetID, pictures:pictures})
                                }
                            }
                        }
                    }
		        }

		        if ("_close_" in window && originURL.indexOf("/2/badge_count/badge_count.json") > 0) {
		            console.debug("TWITTER_NOTIF  preload originURL.indexOf ", json)
                    var dm_badge = json.dm_unread_count
                    var ntab_badge = json.ntab_unread_count
                    var total_badge = json.total_unread_count
                    _fas_.badgeNotification(dm_badge, ntab_badge, total_badge)
                    window._fas_checkCompletedProcesses('badge_detection')
                }


		    } catch (ex) {
		        console.error("error parsing response", ex)
		        return false
		    }
		};

        (function(send) {
            XMLHttpRequest.prototype.send = function () {
              var callback = this.onreadystatechange;
              this.onreadystatechange = function() {
                  if (this.handleJSONResponse != null && this.readyState == 4) {
                    try {
                        var responseType = this.getResponseHeader("Content-Type");
                        if (responseType != null && (responseType.indexOf("application/json") == 0 || responseType.indexOf("application/x-javascript") == 0)){
                            var json = this.response;
                            var prefix = "for (;;);";
                            if (json != null && json.indexOf(prefix) == 0){
                                json = json.substring(prefix.length);
                            }
                            var newResponse = this.handleJSONResponse(JSON.parse(json), this.responseURL);
                             if (newResponse) {
                                 Object.defineProperty(this, 'responseText', {
                                     writable: true
                                 });
                                 // console.debug("JSON Ajax",this.responseURL, JSON.parse(newResponse));
                                 // console.debug("overriding response text",newResponse);
                                 this.responseText = newResponse;
                             }
                        }
                    } catch(ex){
                       console.debug("error parsing response", ex);
                    }
                }
                if (callback) {
                   callback.apply(this, arguments);
                }
              }
              send.apply(this, arguments)
            }
          }(XMLHttpRequest.prototype.send));

})